package imageanalyzer;

import java.awt.image.BufferedImage;

public class Trasforma {

	// estrae il rosso 0-255
	public static int getR(int rgb) {
		return (rgb & 0xFF0000) >> 16;
	}

	// estrae il verde 0-255
	public static int getG(int rgb) {
		return (rgb & 0x00FF00) >> 8;
	}

	// estrae il blu 0-255
	public static int getB(int rgb) {
		return (rgb & 0x0000FF) >> 0;
	}

	// costruisce tripletta rgb
	public static int rgb(int r, int g, int b) {
		return (r << 16) | (g << 8) | (b << 0);
	}

	// trasforma in scala di grigi
	public static BufferedImage inScalaDiGrigi(BufferedImage immagine) {
		int width = immagine.getWidth(), height = immagine.getHeight();
		BufferedImage nuovaImmagine = new BufferedImage(width, height, immagine.getType());
		int pixel, r, g, b, grigio;

		for (int y = 0; y < height; y++)
			for (int x = 0; x < width; x++) {
				pixel = immagine.getRGB(x, y);
				r = getR(pixel);
				g = getG(pixel);
				b = getB(pixel);
				// per coefficienti di conversione vedere ad esempio
				// https://it.wikipedia.org/wiki/YUV
				grigio = (299 * r + 587 * g + 114 * b + 500) / 1000;
				nuovaImmagine.setRGB(x, y, rgb(grigio, grigio, grigio));
			}
		return nuovaImmagine;
	}

}
